"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var js_cookie_1 = require("js-cookie");
var operators_1 = require("rxjs/operators");
// tslint:disable:no-this
// tslint:disable-next-line:no-class
var CookieService = /** @class */ (function () {
    function CookieService() {
        this.cookieSource = new rxjs_1.Subject();
        this.changeSource = new rxjs_1.Subject();
        this.valueChange = this.changeSource.asObservable();
        this.valueChanges = this.cookieSource.asObservable();
    }
    CookieService.prototype.targetValueChange = function (key) {
        return this.valueChange.pipe(operators_1.filter(function (a) { return a && a.key === key; }));
    };
    CookieService.prototype.set = function (name, value, opts) {
        js_cookie_1.set(name, value, opts);
        this.updateSource();
        this.broadcastChange(name);
    };
    CookieService.prototype.remove = function (name, opts) {
        js_cookie_1.remove(name, opts);
        this.updateSource();
        this.broadcastChange(name);
    };
    CookieService.prototype.get = function (name) {
        return js_cookie_1.getJSON(name);
    };
    CookieService.prototype.getAll = function () {
        return js_cookie_1.getJSON();
    };
    CookieService.prototype.updateSource = function () {
        this.cookieSource.next(this.getAll());
    };
    CookieService.prototype.broadcastChange = function (key) {
        this.changeSource.next({
            key: key,
            value: this.get(key)
        });
    };
    CookieService.decorators = [
        { type: core_1.Injectable },
    ];
    return CookieService;
}());
exports.CookieService = CookieService;
//# sourceMappingURL=cookies.browser.service.js.map