"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var tokens_1 = require("@nguniversal/express-engine/tokens");
var core_1 = require("@angular/core");
var express = require("express");
// tslint:disable:no-this
// tslint:disable-next-line:no-class
var ServerCookieService = /** @class */ (function () {
    function ServerCookieService(req) {
        this.req = req;
        this.valueChange = rxjs_1.empty();
        this.valueChanges = rxjs_1.empty();
    }
    ServerCookieService.prototype.targetValueChange = function () {
        return rxjs_1.empty();
    };
    ServerCookieService.prototype.get = function (name) {
        try {
            return JSON.parse(this.req.cookies[name]);
        }
        catch (err) {
            return this.req ? this.req.cookies[name] : undefined;
        }
    };
    ServerCookieService.prototype.getAll = function () {
        return this.req && this.req.cookies;
    };
    ServerCookieService.prototype.set = function () {
        // noop
    };
    ServerCookieService.prototype.remove = function () {
        // noop
    };
    ServerCookieService.prototype.updateSource = function () {
        // noop
    };
    ServerCookieService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ServerCookieService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [tokens_1.REQUEST,] }] }
    ]; };
    return ServerCookieService;
}());
exports.ServerCookieService = ServerCookieService;
//# sourceMappingURL=cookies.server.service.js.map