"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var environment_service_1 = require("./environment.service");
var common_1 = require("./common");
var platform_browser_1 = require("@angular/platform-browser");
var operators_1 = require("rxjs/operators");
var tokens_1 = require("@nguniversal/express-engine/tokens");
function getConfigFromProcess() {
    return JSON.parse(process.env.FUSING_ANGULAR || '{}');
}
function serverEnvConfigFactory() {
    return getConfigFromProcess();
}
exports.serverEnvConfigFactory = serverEnvConfigFactory;
// IF ENV CONTAINS SERVER_, remove from object
function removeServerSpecific(obj, filterKey) {
    if (filterKey === void 0) { filterKey = 'SERVER_'; }
    return Object.keys(obj)
        .filter(function (key) { return !key.includes(filterKey); })
        .reduce(function (acc, curr) {
        var _a;
        return __assign({}, acc, (_a = {}, _a[curr] = obj[curr], _a));
    }, {});
}
function onBootstrap(appRef, transferState, req) {
    return function () {
        appRef.isStable
            .pipe(operators_1.filter(Boolean), operators_1.first(), operators_1.take(1))
            .subscribe(function () {
            transferState.set(common_1.ENV_CONFIG_TS_KEY, removeServerSpecific(getConfigFromProcess()));
        });
    };
}
exports.onBootstrap = onBootstrap;
// tslint:disable-next-line:no-class
var EnvironmentServerModule = /** @class */ (function () {
    function EnvironmentServerModule() {
    }
    EnvironmentServerModule.decorators = [
        { type: core_1.NgModule, args: [{
                    providers: [
                        environment_service_1.EnvironmentService,
                        { provide: common_1.ENV_CONFIG, useFactory: serverEnvConfigFactory },
                        {
                            provide: core_1.APP_BOOTSTRAP_LISTENER,
                            useFactory: onBootstrap,
                            deps: [core_1.ApplicationRef, platform_browser_1.TransferState, tokens_1.REQUEST],
                            multi: true
                        }
                    ]
                },] },
    ];
    return EnvironmentServerModule;
}());
exports.EnvironmentServerModule = EnvironmentServerModule;
//# sourceMappingURL=environment.server.module.js.map