"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var auth_1 = require("angularfire2/auth");
var operators_1 = require("rxjs/operators");
var tokens_1 = require("./tokens");
var rxjs_1 = require("rxjs");
var common_1 = require("@angular/common");
var browser_1 = require("../../cookies/browser");
// tslint:disable:no-this
function toExtractIdTokenFromUser(user) {
    return user ? user.getIdToken() : rxjs_1.of(undefined).toPromise();
}
function storeJwtInCookies(cs, storageKey) {
    return function (jwt) {
        jwt ? cs.set(storageKey, jwt) : cs.remove(storageKey);
    };
}
// tslint:disable-next-line:no-class
var FirebaseAuthBrowserModule = /** @class */ (function () {
    function FirebaseAuthBrowserModule(auth, cs, stoKey, doc) {
        var _this = this;
        this.auth = auth;
        this.cs = cs;
        this.doc = doc;
        this.waitingOnLoginProcess_ = this.cs
            .targetValueChange('waitOnAuthResponse')
            .pipe(operators_1.map(function (a) { return a.value; }), operators_1.startWith(this.cs.get('waitOnAuthResponse')), operators_1.map(function (val) { return (val && val === true ? true : false); }), operators_1.distinctUntilChanged(), operators_1.share());
        auth.user
            .pipe(operators_1.flatMap(toExtractIdTokenFromUser))
            .subscribe(storeJwtInCookies(cs, stoKey));
        this.waitingOnLoginProcess_.subscribe(function (v) {
            setTimeout(function () {
                var container = _this.doc.querySelector('fng-firebase-spin-container');
                // tslint:disable:no-if-statement
                if (container) {
                    if (v) {
                        container.style.display = 'block';
                    }
                    else {
                        container.style.display = 'none';
                    }
                }
            }, 0);
        });
        this.auth.auth.getRedirectResult().then(function () {
            _this.cs.remove('waitOnAuthResponse');
        });
    }
    FirebaseAuthBrowserModule.decorators = [
        { type: core_1.NgModule },
    ];
    /** @nocollapse */
    FirebaseAuthBrowserModule.ctorParameters = function () { return [
        { type: auth_1.AngularFireAuth },
        { type: browser_1.CookieService },
        { type: String, decorators: [{ type: core_1.Inject, args: [tokens_1.FIREBASE_AUTH_COOKIE_STO_KEY,] }] },
        { type: HTMLDocument, decorators: [{ type: core_1.Inject, args: [common_1.DOCUMENT,] }] }
    ]; };
    return FirebaseAuthBrowserModule;
}());
exports.FirebaseAuthBrowserModule = FirebaseAuthBrowserModule;
//# sourceMappingURL=browser.auth.module.js.map