"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var auth_1 = require("angularfire2/auth");
var server_auth_service_1 = require("./server.auth.service");
var server_common_1 = require("./server.common");
var firebase_admin_1 = require("firebase-admin");
var environment_1 = require("../../environment");
var tokens_1 = require("./tokens");
var browser_1 = require("../../cookies/browser");
var platform_browser_1 = require("@angular/platform-browser");
var operators_1 = require("rxjs/operators");
var browser_auth_service_1 = require("./browser.auth.service");
function firebaseAdminAppAlreadyExists() {
    return firebase_admin_1.apps.length ? true : false;
}
function repairInlinePem(str) {
    return str ? str.replace(/\\n/g, '\n') : '';
}
function fbAdminFactory(es) {
    !firebaseAdminAppAlreadyExists() &&
        firebase_admin_1.initializeApp({
            credential: firebase_admin_1.credential.cert({
                projectId: es.config.FIREBASE_PROJECT_ID,
                clientEmail: es.config.SERVER_FIREBASE_CLIENT_EMAIL,
                privateKey: repairInlinePem(es.config.SERVER_FIREBASE_PRIVATE_KEY)
            }),
            databaseURL: es.config.FIREBASE_DATABASE_URL
        });
    return firebase_admin_1.auth();
}
exports.fbAdminFactory = fbAdminFactory;
function getUserJwt(cs, key) {
    return cs.get(key);
}
exports.getUserJwt = getUserJwt;
function onBootstrap(transferState, auth, tsKey) {
    return function () {
        return auth.user
            .pipe(operators_1.take(1), operators_1.tap(function (user) { return transferState.set(tsKey, user); }))
            .toPromise();
    };
}
exports.onBootstrap = onBootstrap;
// tslint:disable-next-line:no-class
var FirebaseAuthServerModule = /** @class */ (function () {
    function FirebaseAuthServerModule() {
    }
    FirebaseAuthServerModule.decorators = [
        { type: core_1.NgModule, args: [{
                    providers: [
                        server_auth_service_1.FirebaseServerAuth,
                        { provide: auth_1.AngularFireAuth, useExisting: server_auth_service_1.FirebaseServerAuth },
                        {
                            provide: browser_auth_service_1.FirebaseUniversalAuthService,
                            useExisting: server_auth_service_1.FirebaseServerAuth
                        },
                        {
                            provide: server_common_1.FIREBASE_AUTH_SERVER_ADMIN_APP,
                            useFactory: fbAdminFactory,
                            deps: [environment_1.EnvironmentService]
                        },
                        {
                            provide: server_common_1.FIREBASE_AUTH_SERVER_USER_JWT,
                            useFactory: getUserJwt,
                            deps: [browser_1.CookieService, tokens_1.FIREBASE_AUTH_COOKIE_STO_KEY]
                        },
                        {
                            provide: core_1.APP_INITIALIZER,
                            useFactory: onBootstrap,
                            deps: [platform_browser_1.TransferState, server_auth_service_1.FirebaseServerAuth, tokens_1.FIREBASE_AUTH_OBJ_TS],
                            multi: true
                        }
                    ]
                },] },
    ];
    return FirebaseAuthServerModule;
}());
exports.FirebaseAuthServerModule = FirebaseAuthServerModule;
//# sourceMappingURL=server.auth.module.js.map