"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var server_common_1 = require("./server.common");
var firebase_admin_1 = require("firebase-admin");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var platform_browser_1 = require("@angular/platform-browser");
var tokens_1 = require("./tokens");
function validateToken(auth, jwt) {
    return rxjs_1.of(auth.verifyIdToken(jwt));
}
function byMappingItToUndefined(err) {
    return rxjs_1.of(undefined);
}
function cacheToBrowser(tsCacheKey, ts) {
    return function (obj) {
        ts.set(tsCacheKey, obj);
    };
}
function toPsuedoUserObject(jwtObj) {
    return {
        isAnonymous: jwtObj.provider_id && jwtObj.provider_id === 'anonymous',
        uid: jwtObj.user_id,
        displayName: jwtObj.name,
        email: jwtObj.email,
        emailVerified: jwtObj.email_verified,
        photoURL: jwtObj.picture,
        phoneNumber: jwtObj.phone_number,
        providerId: jwtObj.firebase && jwtObj.firebase.sign_in_provider
    };
}
// tslint:disable:no-this
// tslint:disable-next-line:no-class
var FirebaseServerAuth = /** @class */ (function () {
    function FirebaseServerAuth(ts, tsCacheKey, authAdmin, jwt) {
        this.ts = ts;
        this.tsCacheKey = tsCacheKey;
        this.authAdmin = authAdmin;
        this.jwt = jwt;
        this.validatedToken_ = this.jwt
            ? validateToken(this.authAdmin, this.jwt).pipe(operators_1.flatMap(function (a) { return a; }), operators_1.map(toPsuedoUserObject), operators_1.tap(cacheToBrowser(this.tsCacheKey, this.ts)), operators_1.catchError(byMappingItToUndefined))
            : rxjs_1.of(null);
        this.user = this.validatedToken_;
        this.authState = this.validatedToken_;
        this.idTokenResult = rxjs_1.of(this.jwt);
        this.idToken = this.jwt;
    }
    FirebaseServerAuth.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    FirebaseServerAuth.ctorParameters = function () { return [
        { type: platform_browser_1.TransferState },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [tokens_1.FIREBASE_AUTH_OBJ_TS,] }] },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [server_common_1.FIREBASE_AUTH_SERVER_ADMIN_APP,] }] },
        { type: String, decorators: [{ type: core_1.Inject, args: [server_common_1.FIREBASE_AUTH_SERVER_USER_JWT,] }] }
    ]; };
    return FirebaseServerAuth;
}());
exports.FirebaseServerAuth = FirebaseServerAuth;
//# sourceMappingURL=server.auth.service.js.map