import { InjectionToken } from '@angular/core';
import { HttpParams } from '@angular/common/http';
export interface LruCache {
    readonly get: <T>(key: string) => T;
    readonly set: <T>(key: string, value: T) => T;
}
export declare const LRU_CACHE: InjectionToken<LruCache>;
export declare const FIREBASE_USER_AUTH_TOKEN: InjectionToken<string>;
export declare function attemptToCacheInLru(key: string, lru?: LruCache): (response?: any) => void;
export declare function attemptToGetLruCachedValue<T>(key: string, lru?: LruCache): T;
export declare function getFullUrl(base: string, params: HttpParams): string;
