"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var crypto_1 = require("crypto");
exports.LRU_CACHE = new core_1.InjectionToken('fng.lru');
exports.FIREBASE_USER_AUTH_TOKEN = new core_1.InjectionToken('fng.fb.svr.usr.auth');
function sha256(data) {
    return crypto_1.createHash('sha256')
        .update(data)
        .digest('base64');
}
function attemptToCacheInLru(key, lru) {
    return function (response) {
        lru && response && lru.set(sha256(key), response);
    };
}
exports.attemptToCacheInLru = attemptToCacheInLru;
function attemptToGetLruCachedValue(key, lru) {
    return lru && lru.get(sha256(key));
}
exports.attemptToGetLruCachedValue = attemptToGetLruCachedValue;
function getFullUrl(base, params) {
    var stringifiedParams = params.toString();
    return stringifiedParams ? base + "?" + params.toString() : base;
}
exports.getFullUrl = getFullUrl;
//# sourceMappingURL=server.js.map