import { EnvironmentService } from '../environment';
export interface IFirebaseEnvConfig {
    readonly [key: string]: string | undefined;
    readonly FIREBASE_API_KEY: string;
    readonly FIREBASE_AUTH_DOMAIN: string;
    readonly FIREBASE_DATABASE_URL: string;
    readonly FIREBASE_PROJECT_ID: string;
    readonly FIREBASE_STORAGE_BUCKET: string;
    readonly FIREBASE_MESSAGING_SENDER_ID: string;
}
export declare function firebaseEnvironmentFactory(es: EnvironmentService<IFirebaseEnvConfig>): {
    apiKey: string;
    authDomain: string;
    databaseURL: string;
    projectId: string;
    storageBucket: string;
    messagingSenderId: string;
};
export declare class FirebaseUniversalAppModule {
}
