"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var core_1 = require("@angular/core");
var database_1 = require("angularfire2/database");
var platform_browser_1 = require("@angular/platform-browser");
var rxjs_1 = require("rxjs");
var object_hash_1 = require("object-hash");
var browser_firebase_rtdb_common_1 = require("./browser.firebase.rtdb.common");
// tslint:disable:no-this
// tslint:disable-next-line:no-class
var UniversalRtDbService = /** @class */ (function () {
    function UniversalRtDbService(angularFireDatabase, ts, appRef) {
        var _this = this;
        this.angularFireDatabase = angularFireDatabase;
        this.ts = ts;
        // tslint:disable-next-line:readonly-keyword
        this.readFromCache = true;
        appRef.isStable
            .pipe(operators_1.filter(Boolean), operators_1.take(1))
            .subscribe(function () { return _this.turnOffCache(); });
    }
    UniversalRtDbService.prototype.turnOffCache = function () {
        // tslint:disable-next-line:no-object-mutation
        this.readFromCache = false;
    };
    UniversalRtDbService.prototype.universalObject = function (path) {
        var cached = this.ts.get(this.cacheKey(path), undefined);
        var base = this.angularFireDatabase
            .object(path)
            .valueChanges()
            .pipe(operators_1.map(function (a) { return (a ? a : undefined); }), operators_1.catchError(function () { return rxjs_1.of(undefined); }));
        return !this.readFromCache
            ? base
            : base.pipe(operators_1.startWith(cached), operators_1.distinctUntilChanged(function (x, y) { return (x && object_hash_1.sha1(x)) === (y && object_hash_1.sha1(y)); }));
    };
    UniversalRtDbService.prototype.universalList = function (path, queryFn) {
        // tslint:disable-next-line:readonly-array
        var cached = this.ts.get(this.cacheKey(path), []);
        var base = this.angularFireDatabase.list(path, queryFn).valueChanges();
        return this.readFromCache
            ? base.pipe(operators_1.startWith(cached), operators_1.distinctUntilChanged(function (x, y) { return (x && object_hash_1.sha1(x)) === (y && object_hash_1.sha1(y)); }))
            : base;
    };
    UniversalRtDbService.prototype.cacheKey = function (path) {
        return platform_browser_1.makeStateKey("RTDB." + browser_firebase_rtdb_common_1.extractRtDbHostFromLib(this.angularFireDatabase) + "/" + path + ".json");
    };
    UniversalRtDbService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    UniversalRtDbService.ctorParameters = function () { return [
        { type: database_1.AngularFireDatabase },
        { type: platform_browser_1.TransferState },
        { type: core_1.ApplicationRef }
    ]; };
    return UniversalRtDbService;
}());
exports.UniversalRtDbService = UniversalRtDbService;
//# sourceMappingURL=browser.firebase.rtdb.service.js.map