"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var database_1 = require("angularfire2/database");
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var server_1 = require("../common/server");
var rxjs_1 = require("rxjs");
var platform_browser_1 = require("@angular/platform-browser");
var server_firebase_rtdb_common_1 = require("./server.firebase.rtdb.common");
var browser_1 = require("../common/browser");
function constructFbUrl(db, path) {
    var query = db.database.ref(path);
    return query.toString() + ".json";
}
function mapUndefined(err) {
    return rxjs_1.of(undefined);
}
function mapEmptyList(err) {
    return rxjs_1.of([]);
}
// tslint:disable:no-this
// tslint:disable-next-line:no-class
var ServerUniversalRtDbService = /** @class */ (function () {
    function ServerUniversalRtDbService(http, afdb, ts, authToken, lru) {
        this.http = http;
        this.afdb = afdb;
        this.ts = ts;
        this.authToken = authToken;
        this.lru = lru;
    }
    ServerUniversalRtDbService.prototype.universalObject = function (path) {
        var url = constructFbUrl(this.afdb, path);
        var params = browser_1.getParams({ auth: this.authToken });
        var cacheKey = server_1.getFullUrl(url, params);
        var cachedValue = server_1.attemptToGetLruCachedValue(cacheKey, this.lru);
        var tsKey = server_firebase_rtdb_common_1.makeRtDbStateTransferKey(url);
        var baseObs = this.http.get(url, { params: params });
        return cachedValue
            ? rxjs_1.of(cachedValue).pipe(operators_1.tap(browser_1.cacheInStateTransfer(this.ts, tsKey)))
            : baseObs.pipe(operators_1.take(1), operators_1.tap(browser_1.removeHttpInterceptorCache(this.ts, cacheKey)), operators_1.tap(browser_1.cacheInStateTransfer(this.ts, tsKey)), operators_1.tap(server_1.attemptToCacheInLru(cacheKey, this.lru)), operators_1.catchError(mapUndefined));
    };
    // tslint:disable:readonly-array
    ServerUniversalRtDbService.prototype.universalList = function (path, queryFn) {
        var query = (queryFn && queryFn(this.afdb.database.ref(path.toString()))) ||
            this.afdb.database.ref(path.toString());
        var internalQueryParams = query.queryParams_;
        var paramsFromString = internalQueryParams.toRestQueryStringParameters();
        var url = query.toString() + ".json";
        var params = browser_1.getParams(__assign({}, paramsFromString, { auth: this.authToken }));
        var cacheKey = server_1.getFullUrl(url, params);
        var tsKey = server_firebase_rtdb_common_1.makeRtDbStateTransferKey(url);
        var baseObs = this.http.get(url, { params: params });
        var cachedValue = server_1.attemptToGetLruCachedValue(cacheKey, this.lru);
        return cachedValue
            ? rxjs_1.of(cachedValue).pipe(operators_1.tap(browser_1.cacheInStateTransfer(this.ts, tsKey)))
            : baseObs.pipe(operators_1.take(1), operators_1.tap(browser_1.removeHttpInterceptorCache(this.ts, url)), operators_1.map(function (val) {
                return Array.isArray(val)
                    ? val.filter(Boolean)
                    : Object.keys(val).map(function (key) { return val[key]; });
            }), operators_1.tap(browser_1.cacheInStateTransfer(this.ts, tsKey)), operators_1.tap(server_1.attemptToCacheInLru(cacheKey, this.lru)), operators_1.catchError(mapEmptyList));
    };
    ServerUniversalRtDbService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ServerUniversalRtDbService.ctorParameters = function () { return [
        { type: http_1.HttpClient },
        { type: database_1.AngularFireDatabase },
        { type: platform_browser_1.TransferState },
        { type: String, decorators: [{ type: core_1.Optional }, { type: core_1.Inject, args: [server_1.FIREBASE_USER_AUTH_TOKEN,] }] },
        { type: undefined, decorators: [{ type: core_1.Optional }, { type: core_1.Inject, args: [server_1.LRU_CACHE,] }] }
    ]; };
    return ServerUniversalRtDbService;
}());
exports.ServerUniversalRtDbService = ServerUniversalRtDbService;
//# sourceMappingURL=server.firebase.rtdb.service.js.map