"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var http_cache_tag_server_module_1 = require("./http-cache-tag.server.module");
var operators_1 = require("rxjs/operators");
// tslint:disable:no-class
// tslint:disable:no-this
// tslint:disable:no-if-statement
var HttpCacheTagInterceptor = /** @class */ (function () {
    function HttpCacheTagInterceptor(config, factory) {
        this.config = config;
        this.factory = factory;
        if (!config.headerKey)
            throw new Error('missing config.headerKey');
        if (!config.cacheableResponseCodes)
            throw new Error('missing config.cacheableResponseCodes');
    }
    HttpCacheTagInterceptor.prototype.isCacheableCode = function (code) {
        return this.config.cacheableResponseCodes.find(function (a) { return a === code; });
    };
    HttpCacheTagInterceptor.prototype.isCacheableUrl = function (url) {
        if (!this.config.cacheableUrls || !url || url === null)
            return true;
        return this.config.cacheableUrls.test(url);
    };
    HttpCacheTagInterceptor.prototype.intercept = function (req, next) {
        var _this = this;
        return next.handle(req).pipe(operators_1.map(function (event) {
            if (event instanceof http_1.HttpResponse &&
                _this.isCacheableCode(event.status) &&
                _this.isCacheableUrl(event.url)) {
                _this.factory(event, _this.config);
            }
            return event;
        }));
    };
    HttpCacheTagInterceptor.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    HttpCacheTagInterceptor.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [http_cache_tag_server_module_1.CACHE_TAG_CONFIG,] }] },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [http_cache_tag_server_module_1.CACHE_TAG_FACTORY,] }] }
    ]; };
    return HttpCacheTagInterceptor;
}());
exports.HttpCacheTagInterceptor = HttpCacheTagInterceptor;
//# sourceMappingURL=http-cache-tag-interceptor.service.js.map