import { InjectionToken, ModuleWithProviders } from '@angular/core';
import { HttpResponse } from '@angular/common/http';
export declare const CACHE_TAG_CONFIG: InjectionToken<CacheTagConfig>;
export declare const CACHE_TAG_FACTORY: InjectionToken<CacheFactory>;
export interface CacheTagConfig {
    readonly headerKey: string;
    readonly cacheableResponseCodes: ReadonlyArray<number>;
    readonly cacheableUrls?: RegExp;
}
export declare type CacheFactory = (httpResponse: HttpResponse<any>, config: CacheTagConfig) => void;
export declare class HttpCacheTagModule {
    static forRoot(configProvider: any, factoryProvider: any): ModuleWithProviders;
    constructor(parentModule: HttpCacheTagModule);
}
