"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tokens_1 = require("@nguniversal/express-engine/tokens");
var core_1 = require("@angular/core");
var express = require("express");
// tslint:disable:no-this
// tslint:disable:no-object-mutation
// tslint:disable-next-line:no-class
var ServerResponseService = /** @class */ (function () {
    function ServerResponseService(response) {
        this.response = response;
    }
    ServerResponseService.prototype.set = function (code, message) {
        this.response.statusCode = code;
        this.response.statusMessage = message || '';
    };
    ServerResponseService.prototype.ok = function () {
        this.set(200);
    };
    ServerResponseService.prototype.badRequest = function (message) {
        if (message === void 0) { message = 'Bad Request'; }
        this.set(400, message);
    };
    ServerResponseService.prototype.unauthorized = function (message) {
        if (message === void 0) { message = 'Unauthorized'; }
        this.set(401, message);
    };
    ServerResponseService.prototype.paymentRequired = function (message) {
        if (message === void 0) { message = 'Payment Required'; }
        this.set(402, message);
    };
    ServerResponseService.prototype.forbidden = function (message) {
        if (message === void 0) { message = 'Forbidden'; }
        this.set(403, message);
    };
    ServerResponseService.prototype.notFound = function (message) {
        if (message === void 0) { message = 'Not Found'; }
        this.set(404, message);
    };
    ServerResponseService.prototype.error = function (message) {
        if (message === void 0) { message = 'Internal Server Error'; }
        this.set(500, message);
    };
    ServerResponseService.prototype.notImplemented = function (message) {
        if (message === void 0) { message = 'Not Implemented'; }
        this.set(501, message);
    };
    ServerResponseService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ServerResponseService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [tokens_1.RESPONSE,] }] }
    ]; };
    return ServerResponseService;
}());
exports.ServerResponseService = ServerResponseService;
//# sourceMappingURL=server.response.service.js.map