"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tokens_1 = require("@nguniversal/express-engine/tokens");
var core_1 = require("@angular/core");
var express = require("express");
// tslint:disable:no-this
// tslint:disable:no-object-mutation
// tslint:disable-next-line:no-class
var HeaderService = /** @class */ (function () {
    function HeaderService(response) {
        this.response = response;
    }
    HeaderService.prototype.getHeader = function (key) {
        return this.response.getHeader(key);
    };
    HeaderService.prototype.setHeader = function (key, value) {
        this.response.header(key, value);
    };
    HeaderService.prototype.setHeaders = function (dictionary) {
        var _this = this;
        Object.keys(dictionary).forEach(function (key) { return _this.setHeader(key, dictionary[key]); });
    };
    HeaderService.prototype.removeHeader = function (key) {
        this.response.removeHeader(key);
    };
    HeaderService.prototype.appendHeader = function (key, value, delimiter) {
        if (delimiter === void 0) { delimiter = ','; }
        var current = this.getHeader(key);
        // tslint:disable-next-line:no-if-statement
        if (!current) {
            this.setHeader(key, value);
        }
        else {
            var newValue = current.split(delimiter).concat([value]).filter(function (el, i, a) { return i === a.indexOf(el); })
                .join(delimiter);
            this.response.header(key, newValue);
        }
    };
    HeaderService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    HeaderService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [tokens_1.RESPONSE,] }] }
    ]; };
    return HeaderService;
}());
exports.HeaderService = HeaderService;
//# sourceMappingURL=header.service.js.map