export declare class Maybe<T> {
    private value?;
    private constructor();
    static some<T>(value: T): Maybe<T>;
    static none<T>(): Maybe<T>;
    static fromValue<T>(value: T): Maybe<NonNullable<T>>;
    getOrElse(defaultValue: T): T;
    map<R>(f: (wrapped: T) => R): Maybe<R>;
    doIfSome<R>(f: (wrapped: T) => R): void;
    flattenMap<R>(f: (wrapped: T) => Maybe<R>): Maybe<R>;
}
