"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:no-this
// tslint:disable-next-line:no-class
var Maybe = /** @class */ (function () {
    function Maybe(value) {
        this.value = value;
    }
    Maybe.some = function (value) {
        // tslint:disable-next-line:no-if-statement
        if (!value) {
            throw Error('Provided value must not be empty');
        }
        return new Maybe(value);
    };
    Maybe.none = function () {
        return new Maybe(undefined);
    };
    Maybe.fromValue = function (value) {
        return value
            ? Maybe.some(value)
            : Maybe.none();
    };
    Maybe.prototype.getOrElse = function (defaultValue) {
        return this.value === undefined ? defaultValue : this.value;
    };
    Maybe.prototype.map = function (f) {
        return this.value === undefined
            ? Maybe.none()
            : Maybe.some(f(this.value));
    };
    Maybe.prototype.doIfSome = function (f) {
        this.value && f(this.value);
    };
    Maybe.prototype.flattenMap = function (f) {
        return this.value === undefined ? Maybe.none() : f(this.value);
    };
    return Maybe;
}());
exports.Maybe = Maybe;
//# sourceMappingURL=maybe.js.map