/// <reference types="ua-parser-js" />
import { Request } from 'express';
export interface IUserAgentService {
    readonly userAgent: () => IUAParser.IResult;
    readonly isiPhone: () => boolean;
    readonly isiPad: () => boolean;
    readonly isMobile: () => boolean;
    readonly isTablet: () => boolean;
    readonly isDesktop: () => boolean;
    readonly isChrome: () => boolean;
    readonly isFirefox: () => boolean;
    readonly isSafari: () => boolean;
    readonly isIE: () => boolean;
    readonly isIE7: () => boolean;
    readonly isIE8: () => boolean;
    readonly isIE9: () => boolean;
    readonly isIE10: () => boolean;
    readonly isIE11: () => boolean;
    readonly isWindows: () => boolean;
    readonly isWindowsXP: () => boolean;
    readonly isWindows7: () => boolean;
    readonly isWindows8: () => boolean;
    readonly isMac: () => boolean;
    readonly isChromeOS: () => boolean;
    readonly isiOS: () => boolean;
    readonly isAndroid: () => boolean;
}
export declare class UserAgentService implements IUserAgentService {
    private platformId;
    private req;
    private _window;
    constructor(platformId: any, req: Request, _window: Window);
    userAgent(): IUAParser.IResult;
    isiPhone(): boolean;
    isiPad(): boolean;
    isMobile(): boolean;
    isTablet(): boolean;
    isDesktop(): boolean;
    isChrome(): boolean;
    isFirefox(): boolean;
    isSafari(): boolean;
    isIE(): boolean;
    isIE7(): boolean;
    isIE8(): boolean;
    isIE9(): boolean;
    isIE10(): boolean;
    isIE11(): boolean;
    isWindows(): boolean;
    isWindowsXP(): boolean;
    isWindows7(): boolean;
    isWindows8(): boolean;
    isMac(): boolean;
    isChromeOS(): boolean;
    isiOS(): boolean;
    isAndroid(): boolean;
}
