"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tokens_1 = require("@nguniversal/express-engine/tokens");
var core_1 = require("@angular/core");
var ua_parser_js_1 = require("ua-parser-js");
var common_1 = require("@angular/common");
var tokens_2 = require("./tokens");
// tslint:disable:no-class
// tslint:disable:no-this
var UserAgentService = /** @class */ (function () {
    function UserAgentService(platformId, req, _window) {
        this.platformId = platformId;
        this.req = req;
        this._window = _window;
    }
    UserAgentService.prototype.userAgent = function () {
        var ua = common_1.isPlatformServer(this.platformId)
            ? new ua_parser_js_1.UAParser(this.req.headers['user-agent'])
            : new ua_parser_js_1.UAParser(this._window.navigator.userAgent);
        return ua.getResult();
    };
    UserAgentService.prototype.isiPhone = function () {
        return this.userAgent().device.type === 'iPhone';
    };
    UserAgentService.prototype.isiPad = function () {
        return this.userAgent().device.type === 'iPad';
    };
    UserAgentService.prototype.isMobile = function () {
        return this.userAgent().device.type === 'mobile';
    };
    UserAgentService.prototype.isTablet = function () {
        return this.userAgent().device.type === 'tablet';
    };
    UserAgentService.prototype.isDesktop = function () {
        return !this.isTablet && !this.isMobile;
    };
    UserAgentService.prototype.isChrome = function () {
        return this.userAgent().browser.name === 'Chrome';
    };
    UserAgentService.prototype.isFirefox = function () {
        return this.userAgent().browser.name === 'Firefox';
    };
    UserAgentService.prototype.isSafari = function () {
        return this.userAgent().browser.name === 'Safari';
    };
    UserAgentService.prototype.isIE = function () {
        return this.userAgent().browser.name === 'IE';
    };
    UserAgentService.prototype.isIE7 = function () {
        return this.isIE && this.userAgent().browser.major === '7';
    };
    UserAgentService.prototype.isIE8 = function () {
        return this.isIE && this.userAgent().browser.major === '8';
    };
    UserAgentService.prototype.isIE9 = function () {
        return this.isIE && this.userAgent().browser.major === '9';
    };
    UserAgentService.prototype.isIE10 = function () {
        return this.isIE && this.userAgent().browser.major === '10';
    };
    UserAgentService.prototype.isIE11 = function () {
        return this.isIE && this.userAgent().browser.major === '11';
    };
    UserAgentService.prototype.isWindows = function () {
        return this.userAgent().os.name === 'Windows';
    };
    UserAgentService.prototype.isWindowsXP = function () {
        return this.isWindows && this.userAgent().os.version === 'XP';
    };
    UserAgentService.prototype.isWindows7 = function () {
        return this.isWindows && this.userAgent().os.version === '7';
    };
    UserAgentService.prototype.isWindows8 = function () {
        return this.isWindows && this.userAgent().os.version === '8';
    };
    UserAgentService.prototype.isMac = function () {
        return this.userAgent().os.name === 'Mac OS X';
    };
    UserAgentService.prototype.isChromeOS = function () {
        return this.userAgent().os.name === 'Chromium OS';
    };
    UserAgentService.prototype.isiOS = function () {
        return this.userAgent().os.name === 'iOS';
    };
    UserAgentService.prototype.isAndroid = function () {
        return this.userAgent().os.name === 'Android';
    };
    UserAgentService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    UserAgentService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [core_1.PLATFORM_ID,] }] },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [tokens_1.REQUEST,] }] },
        { type: Window, decorators: [{ type: core_1.Inject, args: [tokens_2.WINDOW,] }] }
    ]; };
    return UserAgentService;
}());
exports.UserAgentService = UserAgentService;
//# sourceMappingURL=user-agent.service.js.map